<!-- Copyright 2017 The Chromium Authors. All rights reserved.
     Use of this source code is governed by a BSD-style license that can be
     found in the LICENSE file. -->

<link rel="import" href="chrome://resources/cr_elements/cr_checkbox/cr_checkbox.html">
<link rel="import" href="chrome://resources/html/action_link.html">
<link rel="import" href="chrome://resources/html/i18n_behavior.html">
<link rel="import" href="chrome://resources/polymer/v1_0/iron-icon/iron-icon.html">

<link rel="import" href="/components/common_styles.html">
<link rel="import" href="/components/hd_iron_icon.html">
<link rel="import" href="/components/oobe_i18n_behavior.html">
<link rel="import" href="/components/oobe_dialog.html">

<dom-module id="oobe-reset-element">
  <template>
    <style include="oobe-dialog-host"></style>
    <link rel="stylesheet" href="chrome://resources/css/throbber.css">
    <link rel="stylesheet" href="oobe_reset.css">
    <oobe-dialog id="resetDialog" role="dialog"
        title-key="resetWarningTitle"
        aria-label$="[[i18nDynamic(locale, 'resetScreenAccessibleTitle')]]"
        has-buttons footer-shrinkable>
      <hd-iron-icon slot="oobe-icon"
          icon1x="oobe-32:alert" icon2x="oobe-64:alert">
      </hd-iron-icon>
      <div slot="subtitle" class="powerwash-warning">
        <!-- Subtitle:  Restart required  -->
        <div hidden="[[!inRestartRequiredState_]]">
          [[i18nDynamic(locale, 'resetRestartMessage')]]
        </div>
        <!-- Subtitle: Powerwash state (depends on powerwash mode) -->
        <div hidden="[[!inPowerwashState_]]">
          <div>[[powerwashStateSubtitle_]]</div>
          <div>
            [[i18nDynamic(locale, 'resetWarningDataDetails')]]
          </div>
        </div>
        <!-- Help Link - Hidden when reverting/rolling back. -->
        <if expr="_google_chrome">
          <a id="powerwash-help-link-md" class="oobe-local-link"
              hidden="[[inRevertState_]]" is="action-link"
              on-click="onLearnMoreTap_">
            [[i18nDynamic(locale, 'learnMore')]]
          </a>
        </if>
        <!-- Spinner - Shown when the revert process is ongoing -->
        <div hidden="[[!inRevertState_]]">
          <div>
            [[i18nDynamic(locale, 'resetRevertPromise')]]
          </div>
          <div class="flex horizontal layout">
            <div id="reset-revert-spinner" class="throbber"></div>
            <div>
              [[i18nDynamic(locale, 'resetRevertSpinnerMessage')]]
            </div>
          </div>
        </div>
      </div>
      <div slot="footer" class="flex layout vertical">
        <!-- Reset screen illustration -->
        <img id="illustration" srcset="images/1x/reset_illustration_1x.svg 1x,
                                       images/2x/reset_illustration_2x.svg 2x"
            alt$="[[i18nDynamic(locale, 'resetScreenIllustrationTitle')]]">
        <!-- TPM Update - Only shown during powerwash state -->
        <div id="tpmFirmwareUpdate" class="layout horizontal"
            hidden="[[!inPowerwashState_]]">
          <cr-checkbox id="tpmFirmwareUpdateCheckbox"
              checked="{{tpmUpdateChecked_}}"
              disabled="[[!tpmUpdateEditable_]]"
              hidden="[[!tpmUpdateAvailable_]]"
              on-change="onTPMFirmwareUpdateChanged_">
            <div id="tpmFirmwareUpdateContainer">
              <span>
                [[i18nDynamic(locale, 'resetTPMFirmwareUpdate')]]
              </span>
              <if expr="_google_chrome">
                <a class="oobe-local-link" is="action-link"
                    on-click="onTPMFirmwareUpdateLearnMore_">
                  [[i18nDynamic(locale, 'learnMore')]]
                </a>
              </if>
            </div>
          </cr-checkbox>
        </div>
      </div>
      <div slot="bottom-buttons" class="flex layout horizontal">
        <div class="flex"></div>
        <!-- Cancel button, only disabled when reverting -->
        <oobe-text-button border on-click="onCancelTap_" text-key="cancelButton"
            id="resetCancel" disabled="[[inRevertState_]]"></oobe-text-button>
        <!-- Restart button -->
        <oobe-text-button inverse on-click="onRestartTap_" class="focus-on-show"
            id="restart" text-key="resetButtonRestart"
            hidden="[[!inRestartRequiredState_]]">
        </oobe-text-button>
        <!-- Powerwash button (depends on powerwash mode) -->
        <oobe-text-button inverse on-click="onPowerwashTap_" class="focus-on-show"
            id="powerwash" hidden="[[!inPowerwashState_]]"
            text-key="[[powerwashButtonTextKey_]]"
            disabled="[[powerwashButtonDisabled_]]">
        </oobe-text-button>
      </div>
    </oobe-dialog>

    <!-- Powerwash confirmation dialog (depends on powerwash mode) -->
    <oobe-modal-dialog id="confirmationDialog" on-close="onDialogClosed_">
      <div slot="title">[[confirmationDialogTitle_]]</div>
      <div slot="content">[[confirmationDialogText_]]</div>
      <div slot="buttons">
        <oobe-text-button id="cancelButton" border on-click="onDialogCancelTap_"
            text-key="cancel"></oobe-text-button>
        <oobe-text-button inverse on-click="onDialogContinueTap_"
            id="confirmPowerwash"
            text-key="confirmResetButton"></oobe-text-button>
      </div>
    </oobe-modal-dialog>
  </template>
</dom-module>
